FROM openshift/golang-builder:rhel_8_golang_1.14 AS builder
ENV __doozer=update BUILD_RELEASE=202010311441.p0 BUILD_VERSION=v4.6.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=6 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.6.0-202010311441.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=f6e5d92 OS_GIT_VERSION=4.6.0-202010311441.p0-f6e5d92 SOURCE_DATE_EPOCH=1601568901 SOURCE_GIT_COMMIT=f6e5d9281f335472dda7110fca2c710794c97fb5 SOURCE_GIT_TAG=v1.14.3-5-gf6e5d92 SOURCE_GIT_URL=https://github.com/operator-framework/operator-registry 

ENV GOPATH /go
ENV PATH $GOPATH/bin:/usr/local/go/bin:$PATH

WORKDIR /src

COPY vendor vendor
COPY cmd cmd
COPY pkg pkg
COPY Makefile go.mod go.sum ./
RUN make build cross

# copy and build vendored grpc_health_probe
RUN CGO_ENABLED=0 go build -mod=vendor -tags netgo -ldflags "-w" ./vendor/github.com/grpc-ecosystem/grpc-health-probe/...

FROM openshift/ose-base:v4.6.0.20201031.150052
ENV __doozer=update BUILD_RELEASE=202010311441.p0 BUILD_VERSION=v4.6.0 OS_GIT_MAJOR=4 OS_GIT_MINOR=6 OS_GIT_PATCH=0 OS_GIT_TREE_STATE=clean OS_GIT_VERSION=4.6.0-202010311441.p0 SOURCE_GIT_TREE_STATE=clean 
ENV __doozer=merge OS_GIT_COMMIT=f6e5d92 OS_GIT_VERSION=4.6.0-202010311441.p0-f6e5d92 SOURCE_DATE_EPOCH=1601568901 SOURCE_GIT_COMMIT=f6e5d9281f335472dda7110fca2c710794c97fb5 SOURCE_GIT_TAG=v1.14.3-5-gf6e5d92 SOURCE_GIT_URL=https://github.com/operator-framework/operator-registry 

COPY --from=builder /src/bin/* /tmp/bin/
COPY --from=builder /src/grpc-health-probe /bin/grpc_health_probe

RUN cp -avr /tmp/bin/. /bin/

RUN mkdir /registry
RUN chgrp -R 0 /registry && \
    chmod -R g+rwx /registry
WORKDIR /registry

# This image doesn't need to run as root user
USER 1001

EXPOSE 50051

ENTRYPOINT ["/bin/registry-server"]
CMD ["--database", "/bundles.db"]

LABEL \
        io.k8s.display-name="OpenShift Operator Registry" \
        io.k8s.description="This is a component of OpenShift Operator Lifecycle Manager and is the base for operator catalog API containers." \
        maintainer="Odin Team <aos-odin@redhat.com>" \
        summary="Operator Registry runs in a Kubernetes or OpenShift cluster to provide operator catalog data to Operator Lifecycle Manager." \
        name="openshift/ose-operator-registry" \
        com.redhat.component="operator-registry-container" \
        io.openshift.maintainer.product="OpenShift Container Platform" \
        io.openshift.maintainer.component="OLM" \
        release="202010311441.p0" \
        io.openshift.build.commit.id="f6e5d9281f335472dda7110fca2c710794c97fb5" \
        io.openshift.build.source-location="https://github.com/operator-framework/operator-registry" \
        io.openshift.build.commit.url="https://github.com/operator-framework/operator-registry/commit/f6e5d9281f335472dda7110fca2c710794c97fb5" \
        version="v4.6.0"

